import { world, system, EquipmentSlot } from "@minecraft/server";
import { TicksPerSecond } from "@minecraft/server";

system.runInterval(
    () => {
        world.getAllPlayers().filter(
            (player) => {
                const equipmentInventory = player.getComponent("equippable");
                if (
                    equipmentInventory.getEquipment(EquipmentSlot.Head)?.typeId == "cata:verdant_helmet"
                ) {
                    player.removeEffect("poison");
                    player.removeEffect("fatal_poison")
                }
                if (equipmentInventory.getEquipment(EquipmentSlot.Head)?.typeId == "cata:stellar_helmet"
                    && equipmentInventory.getEquipment(EquipmentSlot.Chest)?.typeId == "cata:stellar_chestplate"
                    && equipmentInventory.getEquipment(EquipmentSlot.Legs)?.typeId == "cata:stellar_leggings"
                    && equipmentInventory.getEquipment(EquipmentSlot.Feet)?.typeId == "cata:stellar_boots"
                ) {
                    player.addEffect("health_boost", TicksPerSecond * 2, { amplifier: 0, showParticles: false });
                }
                if (equipmentInventory.getEquipment(EquipmentSlot.Feet)?.typeId == "cata:stellar_boots") {
                    //player.addEffect("health_boost", TicksPerSecond * 2, { amplifier: 0, showParticles: false });
                    const velocity = player.getVelocity();
                    if (player.isSneaking && player.isJumping && velocity.x >= 0 && velocity.z >= 0 && player.isOnGround) {
                        entity.applyKnockback({ x: -source.getViewDirection().x * 0, z: -source.getViewDirection().z * 0 }, 1.4);
                        player.runCommandAsync("particle cata:astral_weapon_emitter ~ ~ ~")
                        player.runCommandAsync('particle cata:tiny_impact ~ ~ ~')
                        player.runCommandAsync("playsound random.explode @a[r=10] ~ ~ ~ 0.5 1.8 0.5")

                    }
                };
            },
        );
    },
);

world.afterEvents.entityHurt.subscribe(event => {
    const equipmentInventory = event.hurtEntity.getComponent("equippable");
    if (event.hurtEntity?.typeId == 'minecraft:player' && equipmentInventory.getEquipment(EquipmentSlot.Head)?.typeId == "cata:stellar_helmet"
        && equipmentInventory.getEquipment(EquipmentSlot.Chest)?.typeId == "cata:stellar_chestplate"
        && equipmentInventory.getEquipment(EquipmentSlot.Legs)?.typeId == "cata:stellar_leggings"
        && equipmentInventory.getEquipment(EquipmentSlot.Feet)?.typeId == "cata:stellar_boots") {
        const random = Math.random()
        if (random < 0.50) {
            event.damageSource.damagingEntity.runCommandAsync("particle cata:astral_weapon_emitter ~ ~ ~")
            event.damageSource.damagingEntity.applyDamage(3)
            event.damageSource.damagingEntity.runCommandAsync("playsound random.explode @a[r=10] ~ ~ ~ 0.05 1.9 0.1")
        } else if (random < 1) return {

        }
    }
})
