import * as server from "@minecraft/server"
import { TicksPerSecond } from "@minecraft/server";
const world = server.world

//mob knockback 
world.afterEvents.entityHurt.subscribe(({ damageSource: { damagingEntity: source }, hurtEntity: player }) => {
    if (!source) return;
    const { x, z } = source.getViewDirection();
    if (source.typeId === 'cata:solar_ray') {
        player.applyKnockback({ x: -source.getViewDirection().x * -0, z: -source.getViewDirection().z * -0 },);
        player.setOnFire(1)
    }
    if (source.typeId === 'cata:stone_golem') {
        player.applyKnockback({ x: -source.getViewDirection().x * -4, z: -source.getViewDirection().z * -4 }, 0.2);
        player.addEffect("weakness", TicksPerSecond * 5, { amplifier: 3, showParticles: false });
        player.addEffect("slowness", TicksPerSecond * 5, { amplifier: 3, showParticles: false });

    }
    if (source.typeId === 'cata:verdant_sentinel') {
        player.addEffect("weakness", TicksPerSecond * 3, { amplifier: 2, showParticles: false });
        player.addEffect("slowness", TicksPerSecond * 3, { amplifier: 2, showParticles: false });
    }
    if (source.typeId === 'cata:stellar_wand_projectile') {
        const random = Math.random()
        if (random < 0.50) {
            player.applyDamage(10, { cause: "entityAttack" })
            player.runCommand('particle cata:astral_crit ~ ~ ~')
            player.runCommand('particle cata:astral_weapon_emitter ~ ~ ~')
        } else if (random < 1) {
            //Nothing
        }
    }
    if (source.typeId === 'cata:solar_wand_projectile') {
        player.setOnFire(3)
    }
});
//knockback tags
world.afterEvents.entityHurt.subscribe(({ damageSource: { damagingEntity: source }, hurtEntity: player }) => {
    if (!source) return;
    const { x, z } = source.getViewDirection();
    if (source.hasTag('normal_attack')) {
        player.applyKnockback({ x: -source.getViewDirection().x * -2, z: -source.getViewDirection().z * -2 }, 0.3);
    }
    if (source.hasTag('heavy_attack')) {
        player.applyKnockback({ x: -source.getViewDirection().x * -3, z: -source.getViewDirection().z * -3 }, 0.8);
    }
    if (source.hasTag('mega_attack')) {
        player.applyKnockback({ x: -source.getViewDirection().x * -5, z: -source.getViewDirection().z * -5 }, 1);
    }
    if (source.hasTag('super_attack')) {
        player.applyKnockback({ x: -source.getViewDirection().x * -7, z: -source.getViewDirection().z * -7 }, 2);
    }
});
world.afterEvents.entityHurt.subscribe(({ damageSource: { damagingEntity: source }, hurtEntity: player }) => {
    if (!source) return; // Ensure the damaging entity exists.
    const { x: dirX, z: dirZ } = source.getViewDirection(); // Get direction vector of the source.
    const offsetDistance = 2; // Distance in front of the source where knockback is applied.
    // Calculate the adjusted location slightly in front of the source.
    const knockbackLocation = {
        x: source.location.x + dirX * offsetDistance,
        y: source.location.y,
        z: source.location.z + dirZ * offsetDistance,
    };
    // Get all entities near the adjusted location.
    const nearbyEntities = source.dimension.getEntities({
        location: knockbackLocation,
        maxDistance: 4.4, // Radius of effect.
    });
    for (const entity of nearbyEntities) {
        if (entity === source) continue; // Skip the source entity itself.

        const { x, z } = source.getViewDirection(); // Reuse direction for knockback.

        // Apply knockback based on the tag of the source entity.
        if (source.typeId === 'gneiss_golem') {
            entity.applyKnockback({ x: -source.getViewDirection().x * -6, z: -source.getViewDirection().z * -6 }, 2);
            entity.applyDamage(40, { cause: "entityAttack" });
        }
    }
});

//area_knockback tags
world.afterEvents.entityHurt.subscribe(({ damageSource: { damagingEntity: source }, hurtEntity: player }) => {
    if (!source) return; // Ensure the damaging entity exists.
    const { x: dirX, z: dirZ } = source.getViewDirection(); // Get direction vector of the source.
    const offsetDistance = 2; // Distance in front of the source where knockback is applied.
    // Calculate the adjusted location slightly in front of the source.
    const knockbackLocation = {
        x: source.location.x + dirX * offsetDistance,
        y: source.location.y,
        z: source.location.z + dirZ * offsetDistance,
    };
    // Get all entities near the adjusted location.
    const nearbyEntities = source.dimension.getEntities({
        location: knockbackLocation,
        maxDistance: 3.5, // Radius of effect.
    });
    for (const entity of nearbyEntities) {
        if (entity === source) continue; // Skip the source entity itself.

        const { x, z } = source.getViewDirection(); // Reuse direction for knockback.

        // Apply knockback based on the tag of the source entity.
        if (source.hasTag('area_normal_attack')) {
            entity.applyKnockback({ x: -source.getViewDirection().x * -1.25, z: -source.getViewDirection().z * -1.25 }, 0.5);
            entity.applyDamage(10, { cause: "entityAttack" });
        }
        if (source.hasTag('area_heavy_attack')) {
            entity.applyKnockback({ x: -source.getViewDirection().x * -7, z: -source.getViewDirection().z * -7 }, 0.5);
            entity.applyDamage(15, { cause: "entityAttack" });
        }
        if (source.hasTag('area_super_attack')) {
            entity.applyKnockback({ x: -source.getViewDirection().x * -7, z: -source.getViewDirection().z * -7 }, 2);
            entity.applyDamage(10, { cause: "entityAttack" });
        }
    }
});