import { world, ItemStack, system } from '@minecraft/server';


//alter_pedestal
system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:alter_pedestal_astral', {
    onPlayerInteract({ block, player, dimension }) {
      const { x, y, z } = block;
      const equipment = player.getComponent('equippable'); {
        const selectedItem = equipment.getEquipment('Mainhand');
        if (selectedItem?.typeId == 'cata:astral_alloy') {
          block.setPermutation(block.permutation.withState('cata:alter_pedestal_astral', true));
          player.playSound('respawn_anchor.charge', { pitch: 1.5, location: player.location, volume: 0.2 })
          if (player.getGameMode() !== "creative") {
            player.runCommand(`clear @s cata:astral_alloy 0 1`)
          }
        }
      }
    }
  })
})
system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:alter_pedestal_astral_remove', {
    onPlayerInteract({ block, player, dimension }) {
      const { x, y, z } = block;
      const equipment = player.getComponent('equippable'); {
        const selectedItem = equipment.getEquipment('Mainhand');
        if (player.isSneaking) {
          block.setPermutation(block.permutation.withState('cata:alter_pedestal_astral', false));
          if (player.getGameMode() !== "creative") {
            dimension.runCommand(`loot spawn ${x} ${y + 1} ${z} loot "alter/astral_alloy"`)
          }
        }
      }
    }
  })
})

system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:alter_pedestal_floret', {
    onPlayerInteract({ block, player, dimension }) {
      const { x, y, z } = block;
      const equipment = player.getComponent('equippable'); {
        const selectedItem = equipment.getEquipment('Mainhand');
        if (selectedItem?.typeId == 'cata:floret_element') {
          block.setPermutation(block.permutation.withState('cata:alter_pedestal_floret', true));
          player.playSound('respawn_anchor.charge', { pitch: 1.5, location: player.location, volume: 0.2 })
          if (player.getGameMode() !== "creative") {
            player.runCommand(`clear @s cata:floret_element 0 1`)
          }
        }
      }
    }
  })
})
system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:alter_pedestal_floret_remove', {
    onPlayerInteract({ block, player, dimension }) {
      const { x, y, z } = block;
      const equipment = player.getComponent('equippable'); {
        const selectedItem = equipment.getEquipment('Mainhand');
        if (player.isSneaking) {
          block.setPermutation(block.permutation.withState('cata:alter_pedestal_floret', false));
          if (player.getGameMode() !== "creative") {
            dimension.runCommand(`loot spawn ${x} ${y + 1} ${z} loot "alter/floret_element"`)
          }
        }
      }
    }
  })
})

system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:alter_pedestal_solar', {
    onPlayerInteract({ block, player, dimension }) {
      const { x, y, z } = block;
      const equipment = player.getComponent('equippable'); {
        const selectedItem = equipment.getEquipment('Mainhand');
        if (selectedItem?.typeId == 'cata:solar_element') {
          block.setPermutation(block.permutation.withState('cata:alter_pedestal_solar', true));
          player.playSound('respawn_anchor.charge', { pitch: 1.5, location: player.location, volume: 0.2 })
          if (player.getGameMode() !== "creative") {
            player.runCommand(`clear @s cata:solar_element 0 1`)
          }
        }
      }
    }
  })
})
system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:alter_pedestal_solar_remove', {
    onPlayerInteract({ block, player, dimension }) {
      const { x, y, z } = block;
      const equipment = player.getComponent('equippable'); {
        const selectedItem = equipment.getEquipment('Mainhand');
        if (player.isSneaking) {
          block.setPermutation(block.permutation.withState('cata:alter_pedestal_solar', false));
          if (player.getGameMode() !== "creative") {
            dimension.runCommand(`loot spawn ${x} ${y + 1} ${z} loot "alter/solar_element"`)
          }
        }
      }
    }
  })
})

system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:alter_pedestal_lunar', {
    onPlayerInteract({ block, player, dimension }) {
      const { x, y, z } = block;
      const equipment = player.getComponent('equippable'); {
        const selectedItem = equipment.getEquipment('Mainhand');
        if (selectedItem?.typeId == 'cata:lunar_element') {
          block.setPermutation(block.permutation.withState('cata:alter_pedestal_lunar', true));
          player.playSound('respawn_anchor.charge', { pitch: 1.5, location: player.location, volume: 0.2 })
          if (player.getGameMode() !== "creative") {
            player.runCommand(`clear @s cata:lunar_element 0 1`)
          }
        }
      }
    }
  })
})
system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:alter_pedestal_lunar_remove', {
    onPlayerInteract({ block, player, dimension }) {
      const { x, y, z } = block;
      const equipment = player.getComponent('equippable'); {
        const selectedItem = equipment.getEquipment('Mainhand');
        if (player.isSneaking) {
          block.setPermutation(block.permutation.withState('cata:alter_pedestal_lunar', false));
          if (player.getGameMode() !== "creative") {
            dimension.runCommand(`loot spawn ${x} ${y + 1} ${z} loot "alter/lunar_element"`)
          }
        }
      }
    }
  })
})
