import { world, ItemStack, system } from '@minecraft/server';

//floret_ore
system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:floret_ore_emitter', {
    onTick({ block, dimension }) {
      const { x, y, z } = block;
      if (block.above().typeId === ('minecraft:air')) {
        dimension.runCommand(`particle cata:floret_ore_emitter ${x} ${y} ${z} `);

      } else if (block.below().typeId === ('minecraft:air')) {
        dimension.runCommand(`particle cata:floret_ore_emitter ${x} ${y} ${z} `);

      } else if (block.north().typeId === ('minecraft:air')) {
        dimension.runCommand(`particle cata:floret_ore_emitter ${x} ${y} ${z} `);

      } else if (block.east().typeId === ('minecraft:air')) {
        dimension.runCommand(`particle cata:floret_ore_emitter ${x} ${y} ${z} `);

      } else if (block.south().typeId === ('minecraft:air')) {
        dimension.runCommand(`particle cata:floret_ore_emitter ${x} ${y} ${z} `);

      } else if (block.west().typeId === ('minecraft:air')) {
        dimension.runCommand(`particle cata:floret_ore_emitter ${x} ${y} ${z} `);

      } else return
    }
  })
})
system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:floret_ore_explosion', {
    onPlayerDestroy({ block, dimension, player }) {
      const { x, y, z } = block;
      const random = Math.random()
      if (random < 0.30) {
        if (player.getGameMode() !== "creative") {
          dimension.runCommand(`particle cata:floret_ore_emitter ${x} ${y} ${z}`);
          dimension.runCommand(`particle cata:floret_ore_explosion ${x} ${y} ${z}`);
          dimension.runCommand(`summon cata:floret_ore_explosion ${x} ${y} ${z}`)
          player.playSound('sound.feral_gas', { pitch: 1, location: player.location, volume: 0.6 })
        }
      } else if (random < 1) {
      }
    }
  })
})

//solar_ore
system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:solar_ore_emitter', {
    onTick({ block, dimension }) {
      const { x, y, z } = block;
      if (block.above().typeId === ('minecraft:air')) {
        dimension.runCommand(`particle cata:solar_ore_emitter ${x} ${y} ${z} `);

      } else if (block.below().typeId === ('minecraft:air')) {
        dimension.runCommand(`particle cata:solar_ore_emitter ${x} ${y} ${z} `);

      } else if (block.north().typeId === ('minecraft:air')) {
        dimension.runCommand(`particle cata:solar_ore_emitter ${x} ${y} ${z} `);

      } else if (block.east().typeId === ('minecraft:air')) {
        dimension.runCommand(`particle cata:solar_ore_emitter ${x} ${y} ${z} `);

      } else if (block.south().typeId === ('minecraft:air')) {
        dimension.runCommand(`particle cata:solar_ore_emitter ${x} ${y} ${z} `);

      } else if (block.west().typeId === ('minecraft:air')) {
        dimension.runCommand(`particle cata:solar_ore_emitter ${x} ${y} ${z} `);

      } else return
    }
  })
})
system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:solar_ore_explosion', {
    onPlayerDestroy({ block, dimension, player }) {
      const { x, y, z } = block;
      const random = Math.random()
      if (random < 0.15) {
        if (player.getGameMode() !== "creative") {
          dimension.runCommand(`particle cata:solar_ore_emitter ${x} ${y} ${z}`);
          dimension.runCommand(`particle cata:solar_ore_explosion ${x} ${y} ${z}`);
          dimension.runCommand(`summon cata:solar_ore_explosion ${x} ${y} ${z}`)
          player.playSound('sound.solar_explosion', { pitch: 1, location: player.location, volume: 0.5 })
        }
      } else if (random < 1) {
      }
    }
  })
})


//astral_dust
system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:astral_dust_emitter', {
    onTick({ block, dimension, player }) {
      const random = Math.random()
      const { x, y, z } = block;
      if (random < 0.50) {
        if (block.above().typeId === ('cata:asteroid')) {
          dimension.runCommand(`particle cata:astral_dust_emitter ${x} ${y} ${z} `);
        }
      }
    }
  })
})


//gneiss_vault and gneiss door lock
system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:verdant_vault_unlock', {
    onPlayerInteract({ player, block, dimension }) {
      const { x, y, z } = block;
      const equipment = player.getComponent('equippable'); {
        const selectedItem = equipment.getEquipment('Mainhand');
        if (selectedItem?.typeId == 'cata:verdant_key') {
          player.runCommand(`execute if block ${x} ${y + 1} ${z} cata:gneiss_door run setblock ${x} ${y + 1} ${z} air destroy`)
          player.runCommand(`execute if block ${x} ${y - 1} ${z} cata:gneiss_door run setblock ${x} ${y - 1} ${z} air destroy`)
          player.runCommand(`execute if block ${x} ${y} ${z - 1} cata:gneiss_door run setblock ${x} ${y} ${z - 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y} ${z + 1} cata:gneiss_door run setblock ${x} ${y} ${z + 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y - 1} ${z - 1} cata:gneiss_door run setblock ${x} ${y - 1} ${z - 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y - 1} ${z + 1} cata:gneiss_door run setblock ${x} ${y - 1} ${z + 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y + 1} ${z + 1} cata:gneiss_door run setblock ${x} ${y + 1} ${z + 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y + 1} ${z - 1} cata:gneiss_door run setblock ${x} ${y + 1} ${z - 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y + 2} ${z + 1} cata:gneiss_door run setblock ${x} ${y + 2} ${z + 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y + 2} ${z - 1} cata:gneiss_door run setblock ${x} ${y + 2} ${z - 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y + 2} ${z} cata:gneiss_door run setblock ${x} ${y + 2} ${z} air destroy`)
          player.runCommand(`setblock ${x} ${y} ${z} air destroy`)
          player.runCommand(`execute if block ${x + 1} ${y} ${z} cata:gneiss_door run setblock ${x + 1} ${y} ${z} air destroy`)
          player.runCommand(`execute if block ${x + 1} ${y + 1} ${z} cata:gneiss_door run setblock ${x + 1} ${y + 1} ${z} air destroy`)
          player.runCommand(`execute if block ${x + 1} ${y + 2} ${z} cata:gneiss_door run setblock ${x + 1} ${y + 2} ${z} air destroy`)
          player.runCommand(`execute if block ${x + 1} ${y - 1} ${z} cata:gneiss_door run setblock ${x + 1} ${y - 1} ${z} air destroy`)
          player.runCommand(`execute if block ${x + -1} ${y} ${z} cata:gneiss_door run setblock ${x + -1} ${y} ${z} air destroy`)
          player.runCommand(`execute if block ${x + -1} ${y + 1} ${z} cata:gneiss_door run setblock ${x + -1} ${y + 1} ${z} air destroy`)
          player.runCommand(`execute if block ${x + -1} ${y + 2} ${z} cata:gneiss_door run setblock ${x + -1} ${y + 2} ${z} air destroy`)
          player.runCommand(`execute if block ${x + -1} ${y - 1} ${z} cata:gneiss_door run setblock ${x + -1} ${y - 1} ${z} air destroy`)
          player.playSound('sound.verdant_door_unlock', { pitch: 1, location: player.location, volume: 1 })
          if (player.getGameMode() !== "creative") {
            player.runCommand(`clear @s cata:verdant_key 0 1`)
          }
        }
      }
    }
  })
})
system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:gneiss_door_unlock', {
    onPlayerInteract({ player, block, dimension }) {
      const { x, y, z } = block;
      const equipment = player.getComponent('equippable'); {
        const selectedItem = equipment.getEquipment('Mainhand');
        if (selectedItem?.typeId == 'cata:master_verdant_key') {
          player.runCommand(`execute if block ${x} ${y + 1} ${z} cata:gneiss_door run setblock ${x} ${y + 1} ${z} air destroy`)
          player.runCommand(`execute if block ${x} ${y - 1} ${z} cata:gneiss_door run setblock ${x} ${y - 1} ${z} air destroy`)
          player.runCommand(`execute if block ${x} ${y} ${z - 1} cata:gneiss_door run setblock ${x} ${y} ${z - 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y} ${z + 1} cata:gneiss_door run setblock ${x} ${y} ${z + 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y - 1} ${z - 1} cata:gneiss_door run setblock ${x} ${y - 1} ${z - 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y - 1} ${z + 1} cata:gneiss_door run setblock ${x} ${y - 1} ${z + 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y + 1} ${z + 1} cata:gneiss_door run setblock ${x} ${y + 1} ${z + 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y + 1} ${z - 1} cata:gneiss_door run setblock ${x} ${y + 1} ${z - 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y + 2} ${z + 1} cata:gneiss_door run setblock ${x} ${y + 2} ${z + 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y + 2} ${z - 1} cata:gneiss_door run setblock ${x} ${y + 2} ${z - 1} air destroy`)
          player.runCommand(`execute if block ${x} ${y + 2} ${z} cata:gneiss_door run setblock ${x} ${y + 2} ${z} air destroy`)
          player.runCommand(`setblock ${x} ${y} ${z} air destroy`)
          player.runCommand(`execute if block ${x + 1} ${y} ${z} cata:gneiss_door run setblock ${x + 1} ${y} ${z} air destroy`)
          player.runCommand(`execute if block ${x + 1} ${y + 1} ${z} cata:gneiss_door run setblock ${x + 1} ${y + 1} ${z} air destroy`)
          player.runCommand(`execute if block ${x + 1} ${y + 2} ${z} cata:gneiss_door run setblock ${x + 1} ${y + 2} ${z} air destroy`)
          player.runCommand(`execute if block ${x + 1} ${y - 1} ${z} cata:gneiss_door run setblock ${x + 1} ${y - 1} ${z} air destroy`)
          player.runCommand(`execute if block ${x + -1} ${y} ${z} cata:gneiss_door run setblock ${x + -1} ${y} ${z} air destroy`)
          player.runCommand(`execute if block ${x + -1} ${y + 1} ${z} cata:gneiss_door run setblock ${x + -1} ${y + 1} ${z} air destroy`)
          player.runCommand(`execute if block ${x + -1} ${y + 2} ${z} cata:gneiss_door run setblock ${x + -1} ${y + 2} ${z} air destroy`)
          player.runCommand(`execute if block ${x + -1} ${y - 1} ${z} cata:gneiss_door run setblock ${x + -1} ${y - 1} ${z} air destroy`)
          player.playSound('sound.verdant_door_unlock', { pitch: 1.2, location: player.location, volume: 1 })
          if (player.getGameMode() !== "creative") {
            player.runCommand(`clear @s cata:master_verdant_key 0 1`)
          }
        }
      }
    }
  })
})


//verdant_crusher interact
system.beforeEvents.startup.subscribe(eventData => {
  eventData.blockComponentRegistry.registerCustomComponent('component:verdant_crusher', {
    onPlayerInteract({ block, dimension, player }) {
      const { x, y, z } = block;
      const equipment = player.getComponent('equippable'); {
        const selectedItem = equipment.getEquipment('Mainhand');
        if (selectedItem?.typeId == 'cata:floret_element') {
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          player.playSound('block.grindstone.use', { pitch: 1, location: player.location, volume: 1 })
          if (player.getGameMode() !== "creative") {
            player.runCommand(`clear @s cata:floret_element 0 1`)
          }
        }
        if (selectedItem?.typeId == 'cata:polished_feralplast') {
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          player.playSound('block.grindstone.use', { pitch: 1, location: player.location, volume: 1 })
          if (player.getGameMode() !== "creative") {
            player.runCommand(`clear @s cata:polished_feralplast 0 1`)
          }
        }
        if (selectedItem?.typeId == 'cata:feralplast_brick') {
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          player.playSound('block.grindstone.use', { pitch: 1, location: player.location, volume: 1 })
          if (player.getGameMode() !== "creative") {
            player.runCommand(`clear @s cata:feralplast_brick 0 1`)
          }
        }
        if (selectedItem?.typeId == 'cata:feral_roots_placer') {
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          player.playSound('block.grindstone.use', { pitch: 1, location: player.location, volume: 1 })
          if (player.getGameMode() !== "creative") {
            player.runCommand(`clear @s cata:feral_roots_placer 0 1`)
          }
        }
        if (selectedItem?.typeId == 'cata:floret_ore') {
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          player.playSound('block.grindstone.use', { pitch: 1, location: player.location, volume: 1 })
          if (player.getGameMode() !== "creative") {
            player.runCommand(`clear @s cata:floret_ore 0 1`)
          }
        }
        if (selectedItem?.typeId == 'cata:floret_block') {
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          player.playSound('block.grindstone.use', { pitch: 1, location: player.location, volume: 1 })
          if (player.getGameMode() !== "creative") {
            player.runCommand(`clear @s cata:floret_block 0 1`)
          }
        }
        if (selectedItem?.typeId == 'cata:feralplast') {
          dimension.runCommand(`summon xp_orb ${x} ${y + 1} ${z}`)
          player.playSound('block.grindstone.use', { pitch: 1, location: player.location, volume: 1 })
          if (player.getGameMode() !== "creative") {
            player.runCommand(`clear @s cata:feralplast 0 1`)
          }
        }
      }
    }
  });
});
