import { world, TicksPerSecond, system } from '@minecraft/server'


//stellar
world.afterEvents.itemUse.subscribe((data => {
    const player = data.source
    const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
    const selectedItem2 = player.getComponent('equippable').getEquipment('Offhand')
    const velocity = player.getVelocity();
    if (!player.isSneaking || player.isSneaking) {
        if (selectedItem?.typeId === 'cata:stellar_wand' && !player.getItemCooldown('wand')) {
            player.startItemCooldown('wand', 20)
            player.runCommand('playanimation @s animation.cataclysmplayer.wand_use')
            player.runCommand("playsound sound.wand @a[r=10] ~ ~ ~ 0.3 2.5 1")
            let launchVel = 0.7;
            const velocity = player.getViewDirection();
            let headLoc = player.getHeadLocation();
            const arrow = player.dimension.spawnEntity('cata:stellar_wand_projectile', { x: headLoc.x + velocity.x, y: headLoc.y + velocity.y, z: headLoc.z + velocity.z });
            const projectileComp = arrow.getComponent('minecraft:projectile');
            projectileComp?.shoot({ x: velocity.x * launchVel, y: velocity.y * launchVel, z: velocity.z * launchVel });
        }
    }
}))


//floret
world.afterEvents.itemUse.subscribe((data => {
    const player = data.source
    const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
    const selectedItem2 = player.getComponent('equippable').getEquipment('Offhand')
    const velocity = player.getVelocity();
    if (!player.isSneaking) {
        if (selectedItem?.typeId === 'cata:floret_wand' && !player.getItemCooldown('wand')) {
            player.startItemCooldown('wand', 20)
            player.runCommand('playanimation @s animation.cataclysmplayer.wand_use')
            player.runCommand("playsound sound.wand @a[r=10] ~ ~ ~ 0.3 1.8 1")
            let launchVel = 1;
            const velocity = player.getViewDirection();
            let headLoc = player.getHeadLocation();
            const arrow = player.dimension.spawnEntity('cata:floret_wand_projectile', { x: headLoc.x + velocity.x, y: headLoc.y + velocity.y, z: headLoc.z + velocity.z });
            const projectileComp = arrow.getComponent('minecraft:projectile');
            projectileComp?.shoot({ x: velocity.x * launchVel, y: velocity.y * launchVel, z: velocity.z * launchVel });
        }
    }
    if (player.isSneaking) {
        if (selectedItem?.typeId === 'cata:floret_wand' && selectedItem2?.typeId === 'cata:floret_tablet_projectile1'
            && !player.getItemCooldown('wand') && !player.getItemCooldown('tablet')) {
            player.startItemCooldown('wand', 20)
            player.startItemCooldown('tablet', 60)
            player.runCommand('playanimation @s animation.cataclysmplayer.wand_use')
            player.runCommand("playsound sound.wand @a[r=10] ~ ~ ~ 0.3 1.8 1")
            let launchVel = 1;
            const velocity = player.getViewDirection();
            let headLoc = player.getHeadLocation();
            const arrow = player.dimension.spawnEntity('cata:floret_wand_projectile_heavy', { x: headLoc.x + velocity.x, y: headLoc.y + velocity.y, z: headLoc.z + velocity.z });
            const projectileComp = arrow.getComponent('minecraft:projectile');
            projectileComp?.shoot({ x: velocity.x * launchVel, y: velocity.y * launchVel, z: velocity.z * launchVel });
        } else if (selectedItem?.typeId === 'cata:floret_wand' && selectedItem2?.typeId === 'cata:floret_tablet_projectile1'
            && !player.getItemCooldown('wand') && player.getItemCooldown('tablet')) {
            player.runCommand("playsound note.bass @s ~ ~ ~ 0.3 1.3 1")
            player.onScreenDisplay.setActionBar("Tablet on cooldown.")
        }
    }
    if (player.isSneaking) {
        if (selectedItem?.typeId === 'cata:floret_wand' && selectedItem2?.typeId === 'cata:floret_tablet_conjure1'
            && !player.getItemCooldown('wand') && !player.getItemCooldown('tablet')) {
            player.startItemCooldown('wand', 20)
            player.startItemCooldown('tablet', 120)
            player.runCommand('playanimation @s animation.cataclysmplayer.wand_use')
            player.runCommand("playsound sound.wand @a[r=10] ~ ~ ~ 0.3 1.8 1")
            const { x: dirX, z: dirZ } = player.getViewDirection();
            const offsetDistance = 2;
            const knockbackLocation = {
                x: player.location.x + dirX * offsetDistance,
                y: player.location.y,
                z: player.location.z + dirZ * offsetDistance,
            }
            const nearbyEntities = player.dimension.getEntities({
                location: knockbackLocation,
                maxDistance: 4,
            });
            for (const entity of nearbyEntities) {
                if (entity === player) continue;
                const { x, z } = player.getViewDirection();
                if (entity.hasComponent('health')) {
                    entity.addEffect("fatal_poison", TicksPerSecond * 2, { amplifier: 1, showParticles: true });
                    entity.runCommand("particle cata:poison_dust ~ ~1 ~")
                    entity.applyDamage(6, { cause: "entityAttack" })
                }
            }
        } else if (selectedItem?.typeId === 'cata:floret_wand' && selectedItem2?.typeId === 'cata:floret_tablet_conjure1'
            && player.getItemCooldown('wand') || !player.getItemCooldown('wand') && player.getItemCooldown('tablet')) {
            player.runCommand("playsound note.bass @s ~ ~ ~ 0.3 1.3 1")
            player.onScreenDisplay.setActionBar("Tablet on cooldown.")
        }
    }
    if (player.isSneaking) {
        if (selectedItem?.typeId === 'cata:floret_wand' && selectedItem2?.typeId === 'cata:floret_tablet_conjure2'
            && !player.getItemCooldown('wand') && !player.getItemCooldown('tablet')) {
            player.startItemCooldown('wand', 20)
            player.startItemCooldown('tablet', 60)
            player.runCommand('playanimation @s animation.cataclysmplayer.wand_use')
            player.runCommand("playsound sound.wand @a[r=10] ~ ~ ~ 0.3 1.8 1")
            const { x: dirX, z: dirZ } = player.getViewDirection();
            const offsetDistance = 2;
            const knockbackLocation = {
                x: player.location.x + dirX * offsetDistance,
                y: player.location.y,
                z: player.location.z + dirZ * offsetDistance,
            }
            const nearbyEntities = player.dimension.getEntities({
                location: knockbackLocation,
                maxDistance: 8,
            });
            for (const entity of nearbyEntities) {
                if (entity === player) continue;
                const { x, z } = player.getViewDirection();
                if (entity.hasComponent('health')) {
                    entity.runCommand("summon cata:feral_fang ~ ~ ~")
                }
            }
        } else if (selectedItem?.typeId === 'cata:floret_wand' && selectedItem2?.typeId === 'cata:floret_tablet_conjure2'
            && player.getItemCooldown('wand') || !player.getItemCooldown('wand') && player.getItemCooldown('tablet')) {
            player.runCommand("playsound note.bass @s ~ ~ ~ 0.3 1.3 1")
            player.onScreenDisplay.setActionBar("Tablet on cooldown.")
        }
    }
}))



//solar
world.afterEvents.itemUse.subscribe((data => {
    const player = data.source
    const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
    const selectedItem2 = player.getComponent('equippable').getEquipment('Offhand')
    const velocity = player.getVelocity();
    if (!player.isSneaking) {
        if (selectedItem?.typeId === 'cata:solar_wand' && !player.getItemCooldown('wand')) {
            player.startItemCooldown('wand', 15)
            player.runCommand('playanimation @s animation.cataclysmplayer.wand_use')
            player.runCommand("playsound sound.wand @a[r=10] ~ ~ ~ 0.5 1.5 1")
            let launchVel = 1;
            const velocity = player.getViewDirection();
            let headLoc = player.getHeadLocation();
            const arrow = player.dimension.spawnEntity('cata:solar_wand_projectile', { x: headLoc.x + velocity.x, y: headLoc.y + velocity.y, z: headLoc.z + velocity.z });
            const projectileComp = arrow.getComponent('minecraft:projectile');
            projectileComp?.shoot({ x: velocity.x * launchVel, y: velocity.y * launchVel, z: velocity.z * launchVel });
        }
    }
    if (player.isSneaking) {
        if (selectedItem?.typeId === 'cata:solar_wand' && selectedItem2?.typeId === 'cata:solar_tablet_projectile1' && !player.getItemCooldown('wand')) {
            player.startItemCooldown('wand', 120)
            player.runCommand('playanimation @s animation.cataclysmplayer.wand_use')
            player.runCommand("playsound sound.wand @a[r=10] ~ ~ ~ 0.5 1.5 1")
            let launchVel = 0.5;
            const velocity = player.getViewDirection();
            let headLoc = player.getHeadLocation();
            const arrow = player.dimension.spawnEntity('cata:large_solar_orb', { x: headLoc.x + velocity.x, y: headLoc.y + velocity.y, z: headLoc.z + velocity.z });
            const projectileComp = arrow.getComponent('minecraft:projectile');
            projectileComp?.shoot({ x: velocity.x * launchVel, y: velocity.y * launchVel, z: velocity.z * launchVel });
        }
    }
    if (player.isSneaking) {
        if (selectedItem?.typeId === 'cata:solar_wand' && selectedItem2?.typeId === 'cata:solar_tablet_conjure1' && !player.getItemCooldown('wand')) {
            player.startItemCooldown('wand', 40)
            player.runCommand("playsound sound.wand @a[r=10] ~ ~ ~ 0.5 1.5 1")
            player.runCommand('playanimation @s animation.cataclysmplayer.wand_use')
            const { x: dirX, z: dirZ } = player.getViewDirection();
            const offsetDistance = 2;
            const knockbackLocation = {
                x: player.location.x + dirX * offsetDistance,
                y: player.location.y,
                z: player.location.z + dirZ * offsetDistance,
            }
            const nearbyEntities = player.dimension.getEntities({
                location: knockbackLocation,
                maxDistance: 8,
            });
            for (const entity of nearbyEntities) {
                if (entity === player) continue;

                const { x, z } = player.getViewDirection();

                if (entity.hasComponent('health')) {
                    entity.setOnFire(3)
                    entity.applyKnockback({ x: -player.getViewDirection().x * 0.4, z: -player.getViewDirection().z * 0.4 }, 0.5);
                    entity.runCommand("playsound sound.solar_swing @a[r=10] ~ ~ ~ 0.5 1.5 1")
                    entity.runCommand("particle cata:morningstar_solar_flame ~ ~1 ~")
                    entity.applyDamage(7, { cause: "entityAttack" })
                }
            }
        }
    }
}))

system.runInterval(
    () => {
        world.getAllPlayers().filter(
            (player) => {
                const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
                const selectedItem2 = player.getComponent('equippable').getEquipment('Offhand')
                if (selectedItem?.typeId === 'cata:floret_wand' && selectedItem2?.typeId === 'cata:floret_tablet_conjure1' && player.isSneaking) {
                    player.runCommand('particle cata:feral_tablet_dis4_emitter ~ ~ ~')
                }
                if (selectedItem?.typeId === 'cata:floret_wand' && selectedItem2?.typeId === 'cata:floret_tablet_conjure2' && player.isSneaking) {
                    player.runCommand('particle cata:feral_tablet_dis8_emitter ~ ~ ~')
                }
                if (selectedItem?.typeId === 'cata:solar_wand' && selectedItem2?.typeId === 'cata:solar_tablet_conjure1' && player.isSneaking) {
                    player.runCommand('particle cata:solar_tablet_dis8_emitter ~ ~ ~')
                }
            }
        )
    }
)