import { world, TicksPerSecond, system } from '@minecraft/server'



world.afterEvents.entityHitEntity.subscribe(data => {

    const mobEvent = data.hitEntity
    const playerEvent = data.damagingEntity

    let invi = playerEvent.getComponent("inventory").container
    let items = invi?.getItem(data?.damagingEntity?.selectedSlotIndex)

    const velocity = playerEvent.getVelocity();
    const random = Math.random()

    //astral_blade
    if (playerEvent?.typeId == "minecraft:player" && items?.typeId == 'cata:astral_blade') {
        if (random < 0.50) {
            mobEvent.applyDamage(13, { cause: "entityAttack" })
            mobEvent.runCommand("particle cata:astral_weapon_emitter ~ ~ ~")
            mobEvent.runCommand("particle cata:astral_crit ~ ~ ~")
            mobEvent.runCommand("playsound mace.smash_air @a[r=10] ~ ~ ~ 0.6 1.3 1")
            mobEvent.applyKnockback({ x: -playerEvent.getViewDirection().x * -0.5, z: -playerEvent.getViewDirection().z * -0.5 }, 0.2);
        } else if (random < 1) {
            return
        }
    }
    //verdant_dagger
    if (playerEvent?.typeId == "minecraft:player" && items?.typeId == 'cata:verdant_dagger') {
        mobEvent.applyKnockback({ x: -playerEvent.getViewDirection().x * -0.001, z: -playerEvent.getViewDirection().z * -0.001 }, 0.001);
        if (!velocity.z == 0 && !velocity.x == 0) {
            mobEvent.applyDamage(6, { cause: "entityAttack" })
            mobEvent.runCommand('particle cata:verdant_dagger ~ ~ ~')
            playerEvent.runCommand("playsound sound.small_sword_swing @a[r=12] ~ ~ ~ 3 1 1")
            playerEvent.addEffect("speed", TicksPerSecond * 3, { amplifier: 2, showParticles: false });
        } else return
    }
    //floret_hatchet
    if (playerEvent?.typeId == "minecraft:player" && items?.typeId == 'cata:floret_hatchet'
        && !playerEvent.getItemCooldown('elemental_weapon')) {
        playerEvent.runCommand("playsound sound.large_sword_swing @a[r=10] ~ ~ ~ 0.3 1.7 1")
        playerEvent.startItemCooldown('elemental_weapon', 70)
        mobEvent.runCommand("particle cata:poison_dust ~ ~1 ~")
        playerEvent.runCommand("particle cata:poison_sweep ^^0.1^1.2")
        mobEvent.addEffect('poison', 5 * 1)
        playerEvent.runCommand('damage @e[r=5,family=!player] 5')
        playerEvent.runCommand('effect @e[r=5,family=!player] poison 2 1 true')
    } else if (playerEvent?.typeId == "minecraft:player" && items?.typeId == 'cata:floret_hatchet'
        && playerEvent.getItemCooldown('elemental_weapon')) {
        mobEvent.addEffect('poison', 3 * 1)
        playerEvent.runCommand("playsound sound.small_sword_swing @a[r=12] ~ ~ ~ 0.8 0.7 1")
    }
    //morningstar
    if (playerEvent?.typeId == "minecraft:player" && items?.typeId == 'cata:morningstar'
        && !playerEvent.getItemCooldown('elemental_weapon')) {
        playerEvent.startItemCooldown('elemental_weapon', 100)
        playerEvent.runCommand("playsound sound.solar_swing @a[r=10] ~ ~ ~ 0.3 1 1")
        mobEvent.applyKnockback({ x: -playerEvent.getViewDirection().x * -0.8, z: -playerEvent.getViewDirection().z * -0.8 }, 0.7);
        mobEvent.runCommand("particle cata:morningstar_solar_flame ~ ~1 ~")
        mobEvent.setOnFire(4)
        mobEvent.applyDamage(25)
    } else if (playerEvent?.typeId == "minecraft:player" && items?.typeId == 'cata:morningstar'
        && playerEvent.getItemCooldown('elemental_weapon')) {
        mobEvent.setOnFire(2)
        playerEvent.runCommand("playsound sound.small_sword_swing @a[r=12] ~ ~ ~ 0.8 0.7 1")
    }
    //verdant_blade
    if (playerEvent?.typeId == "minecraft:player" && items?.typeId == 'cata:verdant_blade') {
        playerEvent.runCommand("playsound sound.large_sword_swing @a[r=10] ~ ~ ~ 0.5 1 1")
        playerEvent.runCommand('particle cata:verdant_sweep ^^0.1^1.2')
        mobEvent.applyKnockback({ x: -playerEvent.getViewDirection().x * -1, z: -playerEvent.getViewDirection().z * -1 }, 0.2);
        playerEvent.playAnimation('animation.cataclysmplayer.verdant_blade_attack')
    }
})

world.afterEvents.entityHurt.subscribe(({ damageSource: { damagingEntity: source }, hurtEntity: player }) => {
    if (!source) return;

    const { x: dirX, z: dirZ } = source.getViewDirection();
    const offsetDistance = 2;
    const knockbackLocation = {
        x: source.location.x + dirX * offsetDistance,
        y: source.location.y,
        z: source.location.z + dirZ * offsetDistance,
    };

    const nearbyEntities = source.dimension.getEntities({
        location: knockbackLocation,
        maxDistance: 5,
    });
    for (const entity of nearbyEntities) {
        if (entity === source) continue;
        const { x, z } = source.getViewDirection();
        let invi = source.getComponent("inventory").container
        let items = invi?.getItem(source?.selectedSlotIndex)


        if (source.typeId == "minecraft:player" && items?.typeId == 'cata:verdant_blade') {
            entity.applyKnockback({ x: -source.getViewDirection().x * -1, z: -source.getViewDirection().z * -1 }, 0.2);
            entity.applyDamage(5, { cause: "entityAttack" })
        }
    }
});