import { world, system } from '@minecraft/server'

world.afterEvents.itemUse.subscribe((data) => {
    const player = data.source
    const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
    const velocity = player.getVelocity();
    if (selectedItem?.typeId === 'cata:astral_blade' && !player.getItemCooldown('onuseitem')
        && player.isSneaking && velocity.y >= 0) {
        player.startItemCooldown('onuseitem', 100)
        player.runCommand("particle cata:astral_weapon_boost ~ ~ ~")
        player.runCommand("particle minecraft:huge_explosion_emitter ~ ~ ~")
        player.runCommand("playsound random.explode @a[r=10] ~ ~ ~ 1 1.5 1")
        player.runCommand("particle cata:small_impact ~ ~ ~")
        player.runCommand('damage @e[r=5,family=!player] 8')
        player.applyKnockback({ x: -player.getViewDirection().x * -1, z: -player.getViewDirection().z * -1 }, 1.3);
    }
})

world.afterEvents.itemUse.subscribe((data) => {
    const player = data.source
    const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
    if (selectedItem?.typeId === 'cata:lunar_sickle' && !player.getItemCooldown('elemental_weapon')) {
        player.startItemCooldown('elemental_weapon', 20)
        player.applyKnockback({ x: -player.getViewDirection().x * 0.8, z: -player.getViewDirection().z * 0.8 }, 0.2);
    }
})

world.afterEvents.itemCompleteUse.subscribe((data) => {
    const player = data.source
    const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
    if (selectedItem?.typeId === 'cata:astral_jel') {
        player.runCommand('effect @s regeneration 10 1 false')
        player.runCommand('effect @s health_boost 15 0 false')
        player.runCommand("particle cata:astral_crit ~ ~ ~")
    }
})

