import { system, world, ItemStack, GameMode } from '@minecraft/server';

console.warn("working")

const itemId = [
    'cata:astral_blade',
];

world.beforeEvents.itemUse.subscribe(evb => {
    const { source: player, itemStack: itemUsed } = evb;
    if (!itemUsed) return;
    const velocity = player.getVelocity();
    if (itemId.includes(itemUsed.typeId) && !player.getItemCooldown('onuseitem') && player.isSneaking && velocity.y >= 0) {
        const playerEquippableComp = player.getComponent("equippable");
        if (!playerEquippableComp) return;
        if (player.matches({ gameMode: GameMode.creative })) return;
        const randomizeChance = Math.random() * 100;
        const itemEnchantmentComp = itemUsed.getComponent("minecraft:enchantable");
        const unbreakingLevel = itemEnchantmentComp?.getEnchantment("unbreaking")?.level ?? 0;
        const breakChance = 100 / (unbreakingLevel + 1);
        if (breakChance < randomizeChance) return;
        const itemUsedDurabilityComp = itemUsed.getComponent("durability");
        if (!itemUsedDurabilityComp) return;
        system.run(function () {
            const maxDurability = itemUsedDurabilityComp.maxDurability
            const currentDamage = itemUsedDurabilityComp.damage
            if (currentDamage >= maxDurability) {
                system.run(() => {
                    player.playSound('random.break', { pitch: 1, location: player.location, volume: 1 })
                    playerEquippableComp.setEquipment("Mainhand", new ItemStack('minecraft:air', 1));
                });
            }
            else if (currentDamage < maxDurability) {
                system.run(() => {
                    itemUsedDurabilityComp.damage += 1;
                    playerEquippableComp.setEquipment("Mainhand", itemUsed);
                });
            }
        })
    }
})

const wandId = [
    'cata:solar_wand',
    'cata:floret_wand',
];

world.beforeEvents.itemUse.subscribe(evb => {
    const { source: player, itemStack: itemUsed } = evb;
    if (!itemUsed) return;

    if (wandId.includes(itemUsed.typeId) && !player.getItemCooldown('wand') && !player.isSneaking
        || wandId.includes(itemUsed.typeId) && !player.getItemCooldown('wand') && player.isSneaking && !player.getItemCooldown('tablet')) {
        const playerEquippableComp = player.getComponent("equippable");
        if (!playerEquippableComp) return;
        if (player.matches({ gameMode: GameMode.creative })) return;
        const randomizeChance = Math.random() * 100;
        const itemEnchantmentComp = itemUsed.getComponent("minecraft:enchantable");
        const unbreakingLevel = itemEnchantmentComp?.getEnchantment("unbreaking")?.level ?? 0;
        const breakChance = 100 / (unbreakingLevel + 1);
        if (breakChance < randomizeChance) return;
        const itemUsedDurabilityComp = itemUsed.getComponent("durability");
        if (!itemUsedDurabilityComp) return;
        system.run(function () {
            const maxDurability = itemUsedDurabilityComp.maxDurability
            const currentDamage = itemUsedDurabilityComp.damage
            if (currentDamage >= maxDurability) {
                system.run(() => {
                    player.playSound('random.break', { pitch: 1, location: player.location, volume: 1 })
                    playerEquippableComp.setEquipment("Mainhand", new ItemStack('minecraft:air', 1));
                });
            }
            else if (currentDamage < maxDurability) {
                system.run(() => {
                    itemUsedDurabilityComp.damage += 1;
                    playerEquippableComp.setEquipment("Mainhand", itemUsed);
                });
            }
        })
    }
})


const stellarwandId = [
    'cata:stellar_wand',
];

world.beforeEvents.itemUse.subscribe(evb => {
    const { source: player, itemStack: itemUsed } = evb;
    if (!itemUsed) return;

    if (stellarwandId.includes(itemUsed.typeId) && !player.getItemCooldown('wand')) {
        const playerEquippableComp = player.getComponent("equippable");
        if (!playerEquippableComp) return;
        if (player.matches({ gameMode: GameMode.creative })) return;
        const randomizeChance = Math.random() * 100;
        const itemEnchantmentComp = itemUsed.getComponent("minecraft:enchantable");
        const unbreakingLevel = itemEnchantmentComp?.getEnchantment("unbreaking")?.level ?? 0;
        const breakChance = 100 / (unbreakingLevel + 1);
        if (breakChance < randomizeChance) return;
        const itemUsedDurabilityComp = itemUsed.getComponent("durability");
        if (!itemUsedDurabilityComp) return;
        system.run(function () {
            const maxDurability = itemUsedDurabilityComp.maxDurability
            const currentDamage = itemUsedDurabilityComp.damage
            if (currentDamage >= maxDurability) {
                system.run(() => {
                    player.playSound('random.break', { pitch: 1, location: player.location, volume: 1 })
                    playerEquippableComp.setEquipment("Mainhand", new ItemStack('minecraft:air', 1));
                });
            }
            else if (currentDamage < maxDurability) {
                system.run(() => {
                    itemUsedDurabilityComp.damage += 1;
                    playerEquippableComp.setEquipment("Mainhand", itemUsed);
                });
            }
        })
    }
})

