import { world, ItemStack, system } from '@minecraft/server';
const slabs = [
    { id: "cata:gneiss_brick_slab" },
    { id: "cata:flare_stone_brick_slab" },
    { id: "cata:asteroid_brick_slab" },
];

system.beforeEvents.startup.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('component:on_interact', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const isSlab = slabs.find((slab) => selectedItem.matches(slab.id))
            if ((isSlab) && !block.permutation.getState('cata:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        selectedItem.amount -= 1;
                        if (selectedItem.amount === 0) {
                            equipment.setEquipment('Mainhand', undefined);
                        } else {
                            equipment.setEquipment('Mainhand', selectedItem);
                        }
                    }
                    block.setPermutation(block.permutation.withState('cata:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.stone');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('cata:waterlogged') && !block.permutation.getState('kai:double')) {
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('cata:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const structureName = (verticalHalf === 'bottom') ? 'mystructure:bottomSlab' : 'mystructure:topSlab';
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});