// Import necessary modules from Minecraft server API
import { world, ItemStack, system } from '@minecraft/server';
const slabs = [
    { id: "cata:gneiss_brick_slab" },
    { id: "cata:flare_stone_brick_slab" },
    { id: "cata:asteroid_brick_slab" },
];
system.beforeEvents.startup.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('component:on_player_destroy', {
        onPlayerDestroy(e) {
            const { block, player } = e;
            const isSlab = slabs.find((slab) => block.typeId(slab.id))
            if (!player || !player.getComponent('equippable')) {
                return;
            }
            const selectedItem = player.getComponent('equippable').getEquipment('Mainhand');
            const isPickaxe = selectedItem && selectedItem.hasTag('minecraft:is_pickaxe');
            if (isPickaxe) {
                const slabItem = new ItemStack('cata:gneiss_brick_slab', 2);
                e.dimension.spawnItem(slabItem, block.location);
                e.dimension.spawnItem(slabItem, block.location);
            }
        }
    });
});
